#include <FunctionHook/Hook.h>
#include <sys/mman.h>
#include <csignal>
#include <cstring>

void FunctionHooking::Detour::createHook(void* source_address, void* destination_address) {
    source = source_address;
    destination = destination_address;

    //Save the bytes to be overwritten from the function prelude.
    memcpy(&overwritten_bytes, source_address, 13);

    //Put the destination address into the jump.
    memcpy(&hook_bytes[2], &destination_address, sizeof(void*));

    //Make the target memory page writable.
    mprotect((void*)((uintptr_t)source_address & ~(sysconf(_SC_PAGE_SIZE)-1)), sysconf(_SC_PAGE_SIZE), PROT_READ|PROT_WRITE|PROT_EXEC);

    //Write the jmp to the beginning of the function prelude.
    memcpy(source_address, hook_bytes, sizeof(hook_bytes));

    //Make the memory page non-writable again.
    mprotect((void*)((uintptr_t)source_address & ~(sysconf(_SC_PAGE_SIZE)-1)), sysconf(_SC_PAGE_SIZE), PROT_READ|PROT_EXEC);
}

void FunctionHooking::Detour::removeHook() {

    //Make the target memory page writable.
    mprotect((void*)((uintptr_t)source & ~(sysconf(_SC_PAGE_SIZE)-1)), sysconf(_SC_PAGE_SIZE), PROT_READ|PROT_WRITE|PROT_EXEC);

    //Replace our hook with the bytes that were originally there.
    memcpy(source, &overwritten_bytes, 13);

    //Make the memory page non-writable again.
    mprotect((void*)((uintptr_t)source & ~(sysconf(_SC_PAGE_SIZE)-1)), sysconf(_SC_PAGE_SIZE), PROT_READ|PROT_EXEC);
}

FunctionHooking::Detour::Detour(void *source_address, void *destination_address) {
    createHook(source_address, destination_address);
}
